#!/usr/bin/python

###################
# load libraries
import os, sys
import pandas as pd
from collections import defaultdict
####################

#********************************************************************
# TASK: Formatting results with nice colnames
# step3a processed the mcsm results to remove all newlines and 
# brought data in a format where the delimiter ":" splits
# data into a convenient format of "colname": "value".
# this script formats the data and outputs a df with each row
# as a mutation and its corresponding mcsm_values

# Requirements:
# input: output of step3a, file containing  "..._output_processed.txt"
	# path: "Data/<drug>/input/processed/<filename>"
# output: formatted .csv file
	# path: "Data/<drug>/input/processed/<filename>"
#***********************************************************************
############# specify variables for input and output paths and filenames
homedir = os.path.expanduser('~') # spyder/python doesn't recognise tilde
basedir = "/git/Data/pyrazinamide/input"

# input
inpath = "/processed"
in_filename = "/complex1_output_processed.txt"
infile = homedir + basedir + inpath + in_filename
print("Input file is:", infile)

# output
outpath = "/processed"
out_filename = "/complex1_formatted_results.csv"
outfile = homedir + basedir + outpath + out_filename
print("Output file is:", outfile)
################## end of variable assignment for input and output files

outCols=[
        'PredictedAffinityChange',
        'Mutationinformation',
        'Wild-type',
        'Position',
        'Mutant-type',
        'Chain',
        'LigandID',
        'Distancetoligand',
        'DUETstabilitychange'
        ]

lines = [line.rstrip('\n') for line in open(infile)]

outputs = defaultdict(list)

for item in lines:
	col, val = item.split(':')
	outputs[col].append(val)

dfOut=pd.DataFrame(outputs)

pd.DataFrame.to_csv(dfOut, outfile, columns=outCols)
